
TYPO3.Flow - Feature # 43819

Status: Resolved Priority: Should have
Author: Christopher Hlubek Category:
Created: 2012-12-10 Assigned To: Christopher Hlubek
Updated: 2013-03-27 Due date:
PHP Version:
Has patch: No
Complexity:
Subject: Support lazy dependency injection of properties
Description

<?php
namespace Test;

class SomeDependency {

    public function __construct() {
        echo "Construct SomeDependency\n";
    }

    public function foo() {
        echo "Foo called\n";
    }

}

class LazyProxy_Original {

    //
    // /**
    //  * @Flow\Inject(lazy=true)
    //  * @var \Test\SomeDependency
    //  */
    // protected $someProperty;

    public function doSomething() {
        for ($i = 0; $i < 4; $i++) {
            $this->someDependency->foo();
        }
        // $this->fooBar->unknown();
    }

}

class LazyProxy extends LazyProxy_Original {

    public function __construct() {
        echo "Construct LazyProxy\n";
    }

    function __get($name) {
        echo "LazyProxy get($name)\n";
        switch ($name) {
            case 'someDependency':
                $object = new SomeDependency();
                break;
            default:
                trigger_error(
                    'Undefined property via __get(): ' . $name,
                    E_USER_NOTICE);
                return NULL;
        }
        $this->{$name} = $object;
        return $object;
    }

}

$lazy = new LazyProxy();
$lazy->doSomething();

?>

Related issues:
related to Core - Feature # 48960: Extbase: Backport lazy dependency injection New 2013-06-08

Associated revisions
Revision ff8608f1 - 2013-03-15 21:21 - Robert Lemke 

[!!!][FEATURE] Lazy Dependency Injection

This introduces lazy dependency injection for dependencies injected
through Property Injection. Instead of loading the respective class
and instantiating the dependency right away, a proxy object is
injected which automatically replaces itself with the real dependency
once a method is called on it.

The @Inject annotation now accepts an optional argument "lazy" which
allows for turning off lazy dependency injection in specific cases.

Please read the new section in the Object Management chapter of
the Flow manual, included in this change set.

Change-Id: Ia61e40708cdb3d00210df9a5630e64aa8f89b82a
Resolves: #43819
Releases: master, 2.0

Revision 7e03bb9e - 2013-03-20 16:53 - Robert Lemke 

[!!!][FEATURE] Lazy Dependency Injection

This introduces lazy dependency injection for dependencies injected
through Property Injection. Instead of loading the respective class
and instantiating the dependency right away, a proxy object is
injected which automatically replaces itself with the real dependency
once a method is called on it.

The @Inject annotation now accepts an optional argument "lazy" which
allows for turning off lazy dependency injection in specific cases.

Please read the new section in the Object Management chapter of
the Flow manual, included in this change set.

Change-Id: Ia61e40708cdb3d00210df9a5630e64aa8f89b82a
Resolves: #43819
Releases: master, 2.0

Revision e2b1413a - 2013-03-27 12:05 - Robert Lemke 

[!!!][FEATURE] Lazy Dependency Injection

This introduces lazy dependency injection for dependencies injected
through Property Injection. Instead of loading the respective class
and instantiating the dependency right away, a proxy object is
injected which automatically replaces itself with the real dependency
once a method is called on it.

The @Inject annotation now accepts an optional argument "lazy" which
allows for turning off lazy dependency injection in specific cases.

Please read the new section in the Object Management chapter of
the Flow manual, included in this change set.

Change-Id: Ia61e40708cdb3d00210df9a5630e64aa8f89b82a
Resolves: #43819
Releases: master, 2.0

History
#1 - 2013-03-14 19:27 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18917

#2 - 2013-03-14 19:31 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18917

#3 - 2013-03-14 19:51 - Gerrit Code Review
Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18917

#4 - 2013-03-14 20:15 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18917

#5 - 2013-03-15 12:53 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18917

#6 - 2013-03-15 13:20 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18917

#7 - 2013-03-15 16:32 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18917

#8 - 2013-03-15 18:34 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18917

#9 - 2013-03-15 21:15 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18917

#10 - 2013-03-15 21:21 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18917

#11 - 2013-03-15 22:36 - Anonymous
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:ff8608f1c296d7cfe8865e629f6d0cdf07a67e61.
#12 - 2013-03-20 16:54 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/19099

#13 - 2013-03-27 12:08 - Gerrit Code Review

Patch set 1 for branch composer has been pushed to the review server.
It is available at https://review.typo3.org/19362

#14 - 2013-03-27 13:37 - Anonymous
- Status changed from Under Review to Resolved

Applied in changeset commit:e2b1413afaa02c35d0b65965e2d64ab9cfcdd8cb.
